<template>
  <div class="relative">
    <div class="flex flex-nowrap pinContainer">
      <section
        v-for="(project, index) in projs"
        :key="index"
        :class="['flex w-full h-full bg-gray-100 panels', 'panel-' + index]"
        :id="'panel-' + index"
      >
        <div class="relative overflow-hidden cuadro-screen gallery-main">
          <div class="absolute z-20 w-full h-full overflow-hidden primero">
            <img
              :src="
                'assets/projects/' +
                handleName(project.title) +
                '/' +
                handleGetImage(project.images, 1)
              "
              alt=""
              class="z-20 object-cover object-center w-full h-full max-w-none"
            />
          </div>
          <div
            class="absolute z-40 w-full h-full transition-all duration-500 transform segundo"
          >
            <img
              :src="
                'assets/projects/' +
                handleName(project.title) +
                '/' +
                handleGetImage(project.images, 2)
              "
              alt=""
              class="z-20 object-cover object-center w-full h-full max-w-none"
            />
          </div>
          <div class="absolute z-20 w-full h-full overflow-hidden tercero">
            <img
              :src="
                'assets/projects/' +
                handleName(project.title) +
                '/' +
                handleGetImage(project.images, 3)
              "
              alt=""
              class="z-20 object-cover object-center w-full h-full max-w-none"
            />
          </div>
        </div>
        <div
          class="relative z-20 flex-col items-center justify-center hidden cuadro-rest lg:flex lg:px-20 contenido"
        >
          <h2
            class="pb-4 text-3xl font-semibold leading-5 text-gray-800 uppercase text-opacity-80"
          >
            {{ project.title }}
          </h2>
          <h3 class="pb-6 text-lg leading-6 text-base-200">
            {{ project.subtitle }}
          </h3>
          <p class="pb-4 leading-5 text-gray-800">{{ project.content }}</p>
          <a
            :href="handleRoute(project.title)"
            class="self-start rounded-none btn btn-outline btn-secondary w-max"
            >ver proyecto</a
          >
        </div>
      </section>
    </div>
  </div>
</template>

<script>
import { gsap } from "gsap";
import { ScrollTrigger } from "gsap/all";

export default {
  props: {
    projs: {
      type: Array,
      default: [],
    },
    rutebase: {
      type: String,
      default: "",
    },
  },
  data() {
    return {
      tl: {},
    };
  },
  mounted() {
    this.pinContainerScene();
  },
  methods: {
    handleRoute(id) {
      return this.rutebase.replace("99", id.replaceAll(' ','_').toLowerCase());
    },
    handleName(name) {
      name = name.toLowerCase();
      return name.replaceAll(" ", "_");
    },
    handleGetImage(imagesString, index) {
      let imagesJson = JSON.parse(imagesString);
      return imagesJson[index];
    },
    pinContainerScene() {
      const Length = this.projs.length;
      gsap.registerPlugin(ScrollTrigger);
      let sections = gsap.utils.toArray(".panels");
      let container = document.querySelector(".pinContainer");
      let elements = gsap.utils.toArray(
        document.querySelectorAll(".panels > .contenido")
      );

      this.tl = gsap.timeline();

      this.tl.to(sections, {
        x: () =>
          -(container.scrollWidth - document.documentElement.clientWidth) +
          "px",
        ease: "none",
        scrollTrigger: {
          pin: true,
          scrub: 1,
          trigger: container,
          end: () =>
            container.scrollWidth - document.documentElement.clientWidth,
          // onUpdate: ({ progress, direction, isActive }) => console.log(progress, direction, isActive)
        },
      });

      elements.forEach((element) => {
        // console.log(element.parentNode.offsetLeft, element.parentNode);
        gsap.from(element, {
          autoAlpha: 0,
          duration: 0.75,
          stagger: 0.25,
          scrollTrigger: {
            scrub: 1,
            start: element.parentNode.offsetLeft,
            trigger: element.parentNode,
            // onUpdate: ({ progress, direction, isActive }) => console.log(progress, direction, isActive,element,'elemento')
          },
        });
      });
    },
  },
};
</script>
